## cairo-dock 3.6.0

=== CMakeLists.txt ===
########### requirements ###############

cmake_minimum_required (VERSION 3.16.0)

project ("cairo-dock" C)

find_package (PkgConfig)
include (CheckLibraryExists)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckSymbolExists)
include (GNUInstallDirs)

########### project ###############

set (VERSION "3.6.0") # no dash, only numbers, dots and maybe alpha/beta/rc, e.g.: 3.3.1 or 3.3.99.alpha1

add_compile_options (-std=c99 -Wall -Wextra -Werror-implicit-function-declaration) # -Wextra -Wwrite-strings -Wuninitialized -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds)
if (NOT DEFINED CMAKE_BUILD_TYPE)
	add_definitions (-O3)
endif()
add_definitions (-DGL_GLEXT_PROTOTYPES="1")
add_definitions (-DCAIRO_DOCK_DEFAULT_ICON_NAME="default-icon.svg")
add_definitions (-DCAIRO_DOCK_ICON="cairo-dock.svg")
add_definitions (-DCAIRO_DOCK_LOGO="cairo-dock-logo.png")
add_definitions (-DCAIRO_DOCK_DATA_DIR="cairo-dock")
add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")


###########     Misc     ###############
macro (enable_if_not_defined MODULE1)
	if (NOT DEFINED ${MODULE1}) # true if not defined
		set (${MODULE1} TRUE)
	endif ()
endmacro (enable_if_not_defined)


##########     Config    ###############

enable_if_not_defined (force-icon-in-menus)
if (force-icon-in-menus)  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=OFF" is provided in the cmake command.
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=1)
else()
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=0)
endif()

############ sources tarball ############

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
set (CPACK_SOURCE_IGNORE_FILES 
	"/build/;/.bzr/;/.bzrignore$;/.git/;/.gitignore$;/config.h$;/gldi-module-config.h$;/gldi-config.h$;/doc/;/misc/;~$;/TODO$;.pyc$;${CPACK_SOURCE_IGNORE_FILES}")
include (CPack)

add_custom_target( dist
	COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
add_custom_target(dist-bzr
	COMMAND bzr export ${CMAKE_PROJECT_NAME}-${VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

########### global variables ###############

if( WIN32 )
	message(FATAL_ERROR "Cairo-Dock requires an air-conditioned room. Please close Windows!")
endif( WIN32 )

set (PACKAGE ${CMAKE_PROJECT_NAME})
string (TIMESTAMP GLDI_COMPILE_DATE)
set (GETTEXT_PACKAGE ${PACKAGE})

set (prefix ${CMAKE_INSTALL_PREFIX})  # /usr/local
set (exec_prefix ${prefix})
set (datadir "${prefix}/${CMAKE_INSTALL_DATAROOTDIR}")  # (...)/share
set (pkgdatadir "${datadir}/${CMAKE_PROJECT_NAME}")  # (...)/cairo-dock
set (mandir "${prefix}/${CMAKE_INSTALL_MANDIR}")  # (...)/man
set (unitdir "${prefix}/lib/systemd/user") # for systemd units (if enabled)

if( CMAKE_SIZEOF_VOID_P EQUAL 8 AND (force-lib64 OR "${FORCE_LIB64}" STREQUAL "yes"))  # 64bits and force install in lib64
	set (libdir "${prefix}/lib64")
elseif (NOT "${LIB_SUFFIX}" STREQUAL "")
	set (libdir "${prefix}/lib${LIB_SUFFIX}")  # (...)/libXX ## some distro use ${LIB_SUFFIX}
else()
	set (libdir "${prefix}/${CMAKE_INSTALL_LIBDIR}")  # (...)/lib or (...)/lib64 or custom ## GNU Install dir
endif()

set (includedir "${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")  # (...)/include
set (bindir "${prefix}/${CMAKE_INSTALL_BINDIR}")  # (...)/bin

if (NOT DEFINED plugins-prefix)
	set (plugins-prefix "${prefix}")
endif()
set (pluginsdir "${plugins-prefix}/${CMAKE_INSTALL_LIBDIR}/cairo-dock")
set (pluginsdatarootdir "${plugins-prefix}/${CMAKE_INSTALL_DATAROOTDIR}/${CMAKE_PROJECT_NAME}")
set (plugins-locale "${plugins-prefix}/${CMAKE_INSTALL_LOCALEDIR}")
set (plugins-gettext "cairo-dock-plugins") # gettext domain used by plugins

if (NOT DEFINED install-pc-path)
	set (install-pc-path "${libdir}/pkgconfig")  # it can be different (for example ${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig on BSD)
endif ()

list(APPEND CMAKE_INSTALL_RPATH ${libdir})

########### dependencies ###############

# check for mandatory dependencies
# for pkg_check_modules -- use semicolon to have more details if a package is missing
set (packages_required_semicolon "glib-2.0 >= 2.40.0;gthread-2.0;cairo;librsvg-2.0;dbus-1;dbus-glib-1;libxml-2.0;gl;glu;libcurl")
# for gldi.pc -- replace semicolons with spaces
STRING (REPLACE ";" " " packages_required "${packages_required_semicolon}") # note: need to use quotes around ${packages_required_semicolon} for this to work!
pkg_check_modules ("PACKAGE" REQUIRED ${packages_required_semicolon})
find_library(MLIB m)
if (MLIB)
  set (PACKAGE_LIBRARIES ${PACKAGE_LIBRARIES} ${MLIB})
  set (lm_required "-lm") # for the .pc -- note: this might result in an error if -lm is not the correct flag
else()
  set (lm_required "")
endif()


# check for Wayland
set (with_wayland no)
set (WAYLAND_FOUND 0)
enable_if_not_defined (enable-wayland-support) # enabled by default
if (enable-wayland-support)
	set (wayland_required "wayland-client")  # for the .pc
	pkg_check_modules ("WAYLAND" ${wayland_required}>=1.0.0)
	if (WAYLAND_FOUND)
		set (HAVE_WAYLAND 1)
		set (with_wayland "yes (${WAYLAND_VERSION})")
	else()
		set (wayland_required)
	endif()
endif()

if (WAYLAND_FOUND)
	enable_if_not_defined (enable-wayland-protocols) # enabled by default
	if (enable-wayland-protocols)
		find_package(ECM NO_MODULE)
		if (ECM_FOUND)
			set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})
			include (FindWaylandScanner)
			if (WaylandScanner_FOUND)
				set (with_wayland_taskbar "yes")
				set (HAVE_WAYLAND_PROTOCOLS 1)
			else()
				set (with_wayland_taskbar "no (cannot find wayland-scanner)")
			endif()
		else()
			set (with_wayland_taskbar "no (cannot find extra-cmake-modules)")
		endif()
	else()
		set (with_wayland_taskbar "no (disabled)")
	endif()
	# json (for Wayfire IPC interface)
	pkg_check_modules ("JSON" "json-c")
	if (JSON_FOUND)
		set (HAVE_JSON 1)
	endif()
endif()

# check for EGL -- enabled by default, although on X, we still use GLX by default
set (with_egl no)
enable_if_not_defined (enable-egl-support)
if (enable-egl-support)
	pkg_check_modules ("EGL" "egl")
	if (EGL_FOUND)
		set (HAVE_EGL 1)
		set (with_egl "yes (${EGL_VERSION})")
	endif()
	if (WAYLAND_FOUND)
		# check separately for libwayland-egl1, which is used in this case
		pkg_check_modules ("WAYLAND_EGL" REQUIRED "wayland-egl")
	endif()
endif()

# check for X11
set (with_x11 no)
set (with_xentend no)
enable_if_not_defined (enable-x11-support) # enabled by default
if (enable-x11-support)
	# check for X11
	set (x11_required "x11")  # for the .pc
	pkg_check_modules ("X11" ${x11_required})
	if (X11_FOUND)
		set (HAVE_X11 1)
		set (with_x11 yes)
	else()
		set (x11_required)
	endif()
	
	# check for GLX -- TODO: using 'pkg_check_modules ("GLX" "glx")' should work, or very old versions do not provide glx.pc?
	enable_if_not_defined (enable-glx-support)
	if (enable-glx-support)
		check_library_exists (GL glXMakeCurrent "" HAVE_GLX)  # HAVE_GLX remains undefined if not found, else it's "1"
	endif()
	
	# check for X extensions
	set (xextend_required "xtst xcomposite xrandr xrender")  # for the .pc
	STRING (REGEX REPLACE " " ";" xextend_required_semicolon ${xextend_required})
	pkg_check_modules ("XEXTEND" "${xextend_required_semicolon}")
	
	if (XEXTEND_FOUND)
		set (HAVE_XEXTEND 1)
		set (with_xentend yes)
		
		pkg_check_modules ("XINERAMA" "xinerama")  # check for Xinerama separately, since it is now replaced by Xrandr >= 1.3
		if (XINERAMA_FOUND)
			set (HAVE_XINERAMA 1)
		endif()
	else()
		set (xextend_required)
	endif()
endif()

# GTK 3
set (gtk_required "gtk+-3.0")  # for the .pc
pkg_check_modules ("GTK" REQUIRED "${gtk_required}>=3.22.0")

STRING (REGEX REPLACE "\\..*" "" GTK_MAJOR "${GTK_VERSION}")
STRING (REGEX REPLACE "[0-9]*\\.([^ ]+)" "\\1" GTK_MINOR "${GTK_VERSION}")  # 3.8.2 => 3.8
STRING (REGEX REPLACE "\\.[0-9]*" "" GTK_MINOR "${GTK_MINOR}") # 3.8 => 8

# add_definitions (-DGTK_DISABLE_DEPRECATED="1")
# add_definitions (-DG_DISABLE_DEPRECATED="1")

# We use crypt(3) which may be in libc, or in libcrypt (eg FreeBSD)
check_library_exists (crypt encrypt "" HAVE_LIBCRYPT)
if (HAVE_LIBCRYPT)
	set (LIBCRYPT_LIBS "-lcrypt")
endif()

check_symbol_exists (LC_MESSAGES "locale.h" HAVE_LC_MESSAGES)
check_include_files ("math.h" HAVE_MATH_H)
check_library_exists (m sin "" HAVE_LIBM)
if (NOT HAVE_LIBM OR NOT HAVE_MATH_H)
	message(FATAL_ERROR "Cairo-Dock requires math.h")
endif()

check_include_files ("dlfcn.h" HAVE_DLFCN_H)
check_library_exists (dl dlopen "" HAVE_LIBDL)
if (HAVE_LIBDL)  # dlopen might be in libc directly as in FreeBSD
	set (LIBDL_LIBRARIES "dl")
endif()
if (NOT HAVE_DLFCN_H)
	message(FATAL_ERROR "Cairo-Dock requires dlfcn.h")
endif()

check_library_exists (intl libintl_gettext "" HAVE_LIBINTL)
if (HAVE_LIBINTL)  # on BSD, we have to link to libintl to be able to use gettext.
	set (LIBINTL_LIBRARIES "intl")
endif()

# check for gtk-layer-shell
set (with_gtk_layer_shell no)
enable_if_not_defined (enable-gtk-layer-shell) # enabled by default
if (enable-gtk-layer-shell)
	if (HAVE_WAYLAND)
		pkg_check_modules ("GTKLAYERSHELL" "gtk-layer-shell-0>=0.6.0")
		if (GTKLAYERSHELL_FOUND)
			set (HAVE_GTK_LAYER_SHELL 1)
			set (with_gtk_layer_shell yes)
		endif()
	endif()
endif()

# systemd service
if (NOT DEFINED enable-systemd-service)
	# detect if system is running systemd
	set (enable-systemd-service FALSE)
	find_program(SYSTEMD_COMMAND systemd-notify)
	if(SYSTEMD_COMMAND)
		execute_process(COMMAND ${SYSTEMD_COMMAND} --booted RESULT_VARIABLE SYSTEMD_RUNNING)
		if (SYSTEMD_RUNNING EQUAL 0)
			set (enable-systemd-service TRUE)
		endif()
	endif()
	if (enable-systemd-service)
		set (with_systemd_service "yes (use '-Denable-systemd-service=False' to disable it)")
	else()
		set (with_systemd_service "no (use '-Denable-systemd-service=True' to enable it)")
	endif()
else()
	if (enable-systemd-service)
		set (with_systemd_service "yes")
	else()
		set (with_systemd_service "no")
	endif()
endif()

########### variables defined at compil time ###############

set (CAIRO_DOCK_SHARE_DATA_DIR ${pkgdatadir})
set (CAIRO_DOCK_SHARE_THEMES_DIR ${pkgdatadir}/themes)
#set (CAIRO_DOCK_MODULES_DIR ${libdir}/cairo-dock)
set (CAIRO_DOCK_LOCALE_DIR "${prefix}/${CMAKE_INSTALL_LOCALEDIR}")
set (CAIRO_DOCK_PLUGINS_LOCALE_DIR "${plugins-locale}")
set (CAIRO_DOCK_THEMES_DIR "themes")  # folder name where themes are saved locally, relatively to the root folder of Cairo-Dock.
set (CAIRO_DOCK_DISTANT_THEMES_DIR "themes3.4")  # folder name where themes are on the server, relatively to the root folder of the server files.
set (CAIRO_DOCK_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})
set (CAIRO_DOCK_PLUGINS_GETTEXT_PACKAGE "${plugins-gettext}")

set (GLDI_GETTEXT_PACKAGE ${GETTEXT_PACKAGE})
set (GLDI_SHARE_DATA_DIR ${pkgdatadir})
if (NOT "${pluginsdatarootdir}" STREQUAL "${pkgdatadir}")
	set (GLDI_PLUGINS_DATA_ROOT "${pluginsdatarootdir}")
endif()
set (GLDI_MODULES_DIR ${pluginsdir})
if (NOT "${pluginsdir}" STREQUAL "${libdir}/cairo-dock")
	set (GLDI_MODULES_DIR_CORE "${libdir}/cairo-dock")
endif()
set (GLDI_BIN_DIR ${bindir})

########### next steps ###############

add_subdirectory (src)
add_subdirectory (data)
add_subdirectory (po)

############# HELP #################
# this is actually a plug-in for cairo-dock, not for gldi
# it uses some functions of cairo-dock (they are binded dynamically), that's why it can't go with other plug-ins
set (GETTEXT_HELP ${GETTEXT_PACKAGE})
set (VERSION_HELP "0.11.0")
set (PACKAGE_HELP "cd-Help")
set (helpdatadir "${pkgdatadir}/plug-ins/Help")
set (dock_version "${VERSION}")
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Help/data/Help.conf.in ${CMAKE_CURRENT_BINARY_DIR}/Help/data/Help.conf)
add_subdirectory (Help)

########### file generation ###############

=== data/CMakeLists.txt ===
add_subdirectory(themes)
add_subdirectory(gauges)
add_subdirectory(explosion)
add_subdirectory(man)
add_subdirectory(icons)
add_subdirectory(images)
add_subdirectory(scripts)
if (enable-desktop-manager)
	add_subdirectory(desktop-manager)
endif()
add_subdirectory(systemd)

########### file generation ###############

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.conf.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.conf)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock-simple.conf.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock-simple.conf)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/main-dock.conf.in ${CMAKE_CURRENT_BINARY_DIR}/main-dock.conf)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/launcher.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/launcher.desktop)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/container.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/container.desktop)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/separator.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/separator.desktop)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/themes.conf.in ${CMAKE_CURRENT_BINARY_DIR}/themes.conf)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.desktop)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock-cairo.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock-cairo.desktop)


########### install files ###############

# misc
install (FILES
	cairo-dock.svg
	readme-default-view
	ChangeLog.txt
	DESTINATION ${pkgdatadir})

# appli icon
install (FILES
	cairo-dock.svg
	DESTINATION ${datadir}/pixmaps)

# conf files
install (FILES
	# lib
	${CMAKE_CURRENT_BINARY_DIR}/main-dock.conf
	${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.conf
	${CMAKE_CURRENT_BINARY_DIR}/launcher.desktop
	${CMAKE_CURRENT_BINARY_DIR}/container.desktop
	${CMAKE_CURRENT_BINARY_DIR}/separator.desktop
	# appli
	${CMAKE_CURRENT_BINARY_DIR}/cairo-dock-simple.conf
	${CMAKE_CURRENT_BINARY_DIR}/themes.conf
	DESTINATION ${pkgdatadir})

# appli desktop file
install (FILES
	${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.desktop
	${CMAKE_CURRENT_BINARY_DIR}/cairo-dock-cairo.desktop
	DESTINATION ${datadir}/applications)

=== po/CMakeLists.txt ===

find_program (MSGFMT_EXECUTABLE msgfmt)

#on cree une nouvelle cible i18n liée à la cible all.
add_custom_target (i18n ALL COMMENT “Building i18n messages.”)

# on liste tous les .po
file (GLOB PO_FILES *.po)

# on parcours cette liste.
foreach (PO_INPUT ${PO_FILES})
	get_filename_component (PO_INPUT_BASE ${PO_INPUT} NAME_WE)  # NAME Without Extension.
	if (NOT "${PO_INPUT_BASE}" STREQUAL "en_GB") # en_GB has been created only for LaunchPad translation tool
		set (MO_OUTPUT ${PO_INPUT_BASE}.gmo)  # le nom du fichier en sortie.
		message (STATUS "  Building ${MO_OUTPUT}...")
		add_custom_command (TARGET i18n POST_BUILD COMMAND ${MSGFMT_EXECUTABLE} -o  ${CMAKE_CURRENT_BINARY_DIR}/${MO_OUTPUT} ${PO_INPUT})  # appel a msgfmt.
		install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/${MO_OUTPUT} DESTINATION ${CAIRO_DOCK_LOCALE_DIR}/${PO_INPUT_BASE}/LC_MESSAGES RENAME ${GETTEXT_PACKAGE}.mo)  # installation du fichier dans le bon repertoire.
	endif()
endforeach ()

=== src/CMakeLists.txt ===

add_subdirectory (gldit)
add_subdirectory (implementations)

SET(cairo_dock_SRCS
	cairo-dock.c
	cairo-dock-user-menu.c 				cairo-dock-user-menu.h 
	cairo-dock-user-interaction.c 		cairo-dock-user-interaction.h 
	cairo-dock-gui-advanced.c 			cairo-dock-gui-advanced.h
	cairo-dock-gui-simple.c 			cairo-dock-gui-simple.h
	cairo-dock-gui-backend.c 			cairo-dock-gui-backend.h
	cairo-dock-gui-commons.c 			cairo-dock-gui-commons.h
	cairo-dock-widget.c 				cairo-dock-widget.h
	cairo-dock-widget-themes.c 			cairo-dock-widget-themes.h
	cairo-dock-widget-items.c 			cairo-dock-widget-items.h
	cairo-dock-widget-config.c 			cairo-dock-widget-config.h
	cairo-dock-widget-plugins.c 		cairo-dock-widget-plugins.h
	cairo-dock-widget-module.c			cairo-dock-widget-module.h
	cairo-dock-widget-config-group.c 	cairo-dock-widget-config-group.h
	cairo-dock-widget-shortkeys.c		cairo-dock-widget-shortkeys.h
)

########### compilation ###############

# Make sure the compiler can find include files from the libraries.
include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_BINARY_DIR}/src/gldit
	${CMAKE_BINARY_DIR}/src
	${CMAKE_SOURCE_DIR}/src/implementations)

# Make sure the linker can find the libraries.
link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${WAYLAND_LIBRARY_DIRS}
	${GTKLAYERSHELL_LIBRARY_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit)

# Add executable that is built from the source files.
add_executable (${PROJECT_NAME}
	${cairo_dock_SRCS} )

set_target_properties (${PROJECT_NAME} PROPERTIES ENABLE_EXPORTS True)

# Link the executable to the librairies.
target_link_libraries (${PROJECT_NAME}
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES}
	gldi
	${LIBINTL_LIBRARIES}
	${JSON_LIBRARIES})

# install the program once it is built.
install(
	TARGETS ${PACKAGE}
	DESTINATION bin)

=== Help/src/CMakeLists.txt ===

########### sources ###############

SET(MODULE_SRCS
	applet-struct.h
	applet-init.c 			applet-init.h
	applet-config.c 			applet-config.h
	applet-notifications.c 		applet-notifications.h
	applet-tips-dialog.c 		applet-tips-dialog.h
	applet-composite.c 		applet-composite.h
)

add_library(${PACKAGE_HELP} SHARED ${MODULE_SRCS})

########### compil ###############
add_definitions (-DMY_APPLET_SHARE_DATA_DIR="${helpdatadir}")
add_definitions (-DMY_APPLET_PREVIEW_FILE="icon.svg")
add_definitions (-DMY_APPLET_CONF_FILE="Help.conf")
add_definitions (-DMY_APPLET_USER_DATA_DIR="Help")
add_definitions (-DMY_APPLET_VERSION="${VERSION_HELP}")
add_definitions (-DMY_APPLET_GETTEXT_DOMAIN="${GETTEXT_HELP}")
add_definitions (-DMY_APPLET_DOCK_VERSION="${dock_version}")
add_definitions (-DMY_APPLET_ICON_FILE="icon.svg")
### uncomment the following line to allow multi-instance applet.
#add_definitions (-DCD_APPLET_MULTI_INSTANCE="1")
### uncomment the following line to allow extended OpenGL drawing.
#add_definitions (-DGL_GLEXT_PROTOTYPES="1")

include_directories (
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_BINARY_DIR}/src
	${CMAKE_BINARY_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/implementations)

link_directories (
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS})

target_link_libraries (${PACKAGE_HELP}
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES})

########### install files ###############

install(TARGETS ${PACKAGE_HELP} DESTINATION "${libdir}/cairo-dock")

=== data/desktop-manager/CMakeLists.txt ===
# Here we assume some link between GTK versions and gnome-session/gnome-flashback versions
if(${GTK_MAJOR} EQUAL 3 AND ${GTK_MINOR} LESS 24)  # GTK < 3.24 (3.22)
	add_subdirectory(gnome-session-3.28)
else()  # GTK >= 3.24
	add_subdirectory(gnome-session-3.36)
endif()

install (FILES cairo-dock-session
	DESTINATION ${bindir}
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

=== data/systemd/CMakeLists.txt ===
if (enable-systemd-service)
	configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cairo-dock.service.in ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.service)
	install (FILES ${CMAKE_CURRENT_BINARY_DIR}/cairo-dock.service DESTINATION ${unitdir})
endif()

=== src/gldit/CMakeLists.txt ===

SET(core_lib_SRCS
	cairo-dock-struct.h
	cairo-dock-global-variables.h 
	cairo-dock-core.c 					cairo-dock-core.h
	cairo-dock-manager.c 				cairo-dock-manager.h
	cairo-dock-object.c 				cairo-dock-object.h
	# icons
	cairo-dock-icon-manager.c 			cairo-dock-icon-manager.h
	cairo-dock-icon-factory.c 			cairo-dock-icon-factory.h
	cairo-dock-icon-facility.c 			cairo-dock-icon-facility.h
	cairo-dock-indicator-manager.c 		cairo-dock-indicator-manager.h
	cairo-dock-applications-manager.c 	cairo-dock-applications-manager.h
	cairo-dock-application-facility.c 	cairo-dock-application-facility.h
	cairo-dock-launcher-manager.c 		cairo-dock-launcher-manager.h
	cairo-dock-stack-icon-manager.c 	cairo-dock-stack-icon-manager.h
	cairo-dock-class-icon-manager.c 	cairo-dock-class-icon-manager.h
	cairo-dock-user-icon-manager.c 		cairo-dock-user-icon-manager.h
	cairo-dock-applet-manager.c 		cairo-dock-applet-manager.h
	cairo-dock-applet-facility.c 		cairo-dock-applet-facility.h
	cairo-dock-separator-manager.c 		cairo-dock-separator-manager.h
	cairo-dock-module-manager.c 		cairo-dock-module-manager.h
	cairo-dock-module-instance-manager.c cairo-dock-module-instance-manager.h
	# containers
	cairo-dock-container.c 				cairo-dock-container.h
	cairo-dock-desklet-manager.c 		cairo-dock-desklet-manager.h
	cairo-dock-desklet-factory.c 		cairo-dock-desklet-factory.h
	cairo-dock-dialog-factory.c 		cairo-dock-dialog-factory.h
	cairo-dock-dialog-manager.c 		cairo-dock-dialog-manager.h
	cairo-dock-flying-container.c 		cairo-dock-flying-container.h
	cairo-dock-dock-manager.c 			cairo-dock-dock-manager.h
	cairo-dock-dock-factory.c 			cairo-dock-dock-factory.h
	cairo-dock-dock-facility.c 			cairo-dock-dock-facility.h
	cairo-dock-dock-visibility.c 		cairo-dock-dock-visibility.h
	cairo-dock-animations.c 			cairo-dock-animations.h
	cairo-dock-backends-manager.c 		cairo-dock-backends-manager.h
	cairo-dock-data-renderer.c 			cairo-dock-data-renderer.h
	cairo-dock-data-renderer-manager.c 	cairo-dock-data-renderer-manager.h
	cairo-dock-file-manager.c 			cairo-dock-file-manager.h
	cairo-dock-themes-manager.c 		cairo-dock-themes-manager.h
	cairo-dock-class-manager.c 			cairo-dock-class-manager.h
	cairo-dock-desktop-manager.c		cairo-dock-desktop-manager.h
	cairo-dock-windows-manager.c		cairo-dock-windows-manager.h
	cairo-dock-image-buffer.c			cairo-dock-image-buffer.h 
	cairo-dock-opengl.c 				cairo-dock-opengl.h
	cairo-dock-opengl-path.c 			cairo-dock-opengl-path.h
	cairo-dock-opengl-font.c 			cairo-dock-opengl-font.h
	cairo-dock-surface-factory.c 		cairo-dock-surface-factory.h
	cairo-dock-draw.c 					cairo-dock-draw.h 
	cairo-dock-draw-opengl.c 			cairo-dock-draw-opengl.h
	# utilities
	cairo-dock-log.c 					cairo-dock-log.h
	cairo-dock-gui-manager.c 			cairo-dock-gui-manager.h
	cairo-dock-gui-factory.c 			cairo-dock-gui-factory.h
	cairo-dock-keybinder.c 				cairo-dock-keybinder.h
	cairo-dock-dbus.c 					cairo-dock-dbus.h 
	cairo-dock-keyfile-utilities.c 		cairo-dock-keyfile-utilities.h
	cairo-dock-packages.c 				cairo-dock-packages.h
	cairo-dock-particle-system.c 		cairo-dock-particle-system.h
	cairo-dock-overlay.c 				cairo-dock-overlay.h
	cairo-dock-task.c 					cairo-dock-task.h
	cairo-dock-config.c 				cairo-dock-config.h
	cairo-dock-utils.c 					cairo-dock-utils.h
	cairo-dock-menu.c 					cairo-dock-menu.h
	cairo-dock-style-manager.c 			cairo-dock-style-manager.h
	cairo-dock-style-facility.c 		cairo-dock-style-facility.h
	cairo-dock-desktop-file-db.c		cairo-dock-desktop-file-db.h
	cdwindow.c                          cdwindow.h
	texture-gradation.h
	gtk3imagemenuitem.c 				gtk3imagemenuitem.h
)

########### compilation ###############

# Make sure the compiler can find include files from the libraries.
include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${XEXTEND_INCLUDE_DIRS}
	${XINERAMA_INCLUDE_DIRS}
	${EGL_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_BINARY_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/implementations)

# Make sure the linker can find the libraries.
link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${EGL_LIBRARY_DIRS}
	${WAYLAND_LIBRARY_DIRS}
	${WAYLAND_EGL_LIBRARY_DIRS}
	${XEXTEND_LIBRARY_DIRS}
	${XINERAMA_LIBRARY_DIRS})

# Define the library
add_library ("gldi" SHARED ${core_lib_SRCS})
STRING (REGEX REPLACE "\\..*" "" SOVERSION "${VERSION}")
set_target_properties ("gldi" PROPERTIES
	# create *nix style library versions + symbolic links
	VERSION ${VERSION}
	SOVERSION ${SOVERSION}
	# allow creating static and shared libs without conflicts
	#CLEAN_DIRECT_OUTPUT 1
	# avoid conflicts between library and binary target names
	#OUTPUT_NAME ${PROJECT_NAME}
)

# Link the result to the librairies.
target_link_libraries("gldi"
	${PACKAGE_LIBRARIES}
	${GTK_LIBRARIES}
	${EGL_LIBRARIES}
	${WAYLAND_LIBRARIES}
	${WAYLAND_EGL_LIBRARIES}
	${XEXTEND_LIBRARIES}
	${XINERAMA_LIBRARIES}
	${LIBCRYPT_LIBS}
	implementations
	${GTKLAYERSHELL_LIBRARIES}
	${LIBDL_LIBRARIES})


configure_file (${CMAKE_CURRENT_SOURCE_DIR}/gldi.pc.in ${CMAKE_CURRENT_BINARY_DIR}/gldi.pc)
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/gldi.pc DESTINATION ${install-pc-path})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so DESTINATION ${libdir})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so.${VERSION} DESTINATION ${libdir})
install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/libgldi.so.${SOVERSION} DESTINATION ${libdir})

########### install files ###############

install(FILES cairo-dock.h DESTINATION ${includedir}/cairo-dock)
install(FILES
	cairo-dock-struct.h 			cairo-dock-global-variables.h
	${CMAKE_CURRENT_BINARY_DIR}/gldi-config.h  # gldi-module-config.h doesn't need to be installed
	gldi-icon-names.h
	cairo-dock-core.h			cairo-dock-manager.h
	cairo-dock-object.h
	cairo-dock-icon-factory.h		cairo-dock-icon-manager.h
	cairo-dock-icon-facility.h
	cairo-dock-applications-manager.h 	cairo-dock-launcher-manager.h
	cairo-dock-separator-manager.h 		cairo-dock-applet-manager.h
	cairo-dock-stack-icon-manager.h			cairo-dock-user-icon-manager.h
	cairo-dock-class-icon-manager.h
	cairo-dock-backends-manager.h
	
	cairo-dock-packages.h
	cairo-dock-data-renderer.h
	cairo-dock-data-renderer-manager.h
	cairo-dock-dock-manager.h		
	cairo-dock-desklet-manager.h
	cairo-dock-dialog-manager.h
	cairo-dock-indicator-manager.h
	cairo-dock-themes-manager.h
	cairo-dock-gui-manager.h
	cairo-dock-file-manager.h
	cairo-dock-desktop-manager.h
	cairo-dock-windows-manager.h
	cairo-dock-class-manager.h
	cairo-dock-opengl.h
	cairo-dock-image-buffer.h
	cairo-dock-config.h
	cairo-dock-module-manager.h
	cairo-dock-module-instance-manager.h
	cairo-dock-container.h
	cairo-dock-dock-factory.h
	cairo-dock-desklet-factory.h
	cairo-dock-dialog-factory.h
	cairo-dock-flying-container.h
	
	cairo-dock-applet-multi-instance.h 	cairo-dock-applet-single-instance.h
	cairo-dock-applet-canvas.h			cairo-dock-applet-facility.h
	
	cairo-dock-draw.h					cairo-dock-draw-opengl.h
	cairo-dock-opengl-path.h 			cairo-dock-opengl-font.h 
	cairo-dock-particle-system.h		cairo-dock-overlay.h
	cairo-dock-dbus.h
	cairo-dock-keyfile-utilities.h		cairo-dock-surface-factory.h
	cairo-dock-log.h					cairo-dock-keybinder.h
	cairo-dock-application-facility.h	cairo-dock-dock-facility.h
	cairo-dock-task.h
	cairo-dock-animations.h
	cairo-dock-gui-factory.h
	cairo-dock-menu.h
	cairo-dock-style-manager.h
	cairo-dock-style-facility.h
	cairo-dock-utils.h
	
	DESTINATION ${includedir}/cairo-dock/gldit)

if (disable-gtk-grip)
	add_definitions (-DENABLE_GTK_GRIP=1)
endif()

=== src/implementations/CMakeLists.txt ===

SET(impl_SRCS
	gdk-move-to-rect-hack.c            	 gdk-move-to-rect-hack.h
	cairo-dock-gauge.c                   cairo-dock-gauge.h
	cairo-dock-graph.c                   cairo-dock-graph.h
	cairo-dock-progressbar.c             cairo-dock-progressbar.h
	cairo-dock-hiding-effect.c           cairo-dock-hiding-effect.h
	cairo-dock-icon-container.c          cairo-dock-icon-container.h
	cairo-dock-default-view.c            cairo-dock-default-view.h
	cairo-dock-compiz-integration.c      cairo-dock-compiz-integration.h
	cairo-dock-kwin-integration.c        cairo-dock-kwin-integration.h
	cairo-dock-gnome-shell-integration.c cairo-dock-gnome-shell-integration.h
	cairo-dock-cinnamon-integration.c    cairo-dock-cinnamon-integration.h
	cairo-dock-wayfire-integration.c     cairo-dock-wayfire-integration.h
	cairo-dock-systemd-integration.c     cairo-dock-systemd-integration.h
	cairo-dock-X-manager.c               cairo-dock-X-manager.h
	cairo-dock-X-utilities.c             cairo-dock-X-utilities.h
	cairo-dock-glx.c                     cairo-dock-glx.h
	cairo-dock-egl.c                     cairo-dock-egl.h
	cairo-dock-wayland-manager.c         cairo-dock-wayland-manager.h
	cairo-dock-wayland-hotspots.c        cairo-dock-wayland-hotspots.h
)
#if ("${HAVE_X11}")
#	SET(impl_SRCS ${impl_SRCS}
#		cairo-dock-X-manager.c               cairo-dock-X-manager.h
#		cairo-dock-glx.c                     cairo-dock-glx.h
#	)
#endif()

if(WaylandScanner_FOUND)
	SET(impl_SRCS
		${impl_SRCS}
		cairo-dock-wayland-wm.c              cairo-dock-wayland-wm.h
		cairo-dock-foreign-toplevel.c        cairo-dock-foreign-toplevel.h
		cairo-dock-cosmic-toplevel.c         cairo-dock-cosmic-toplevel.h
		cairo-dock-plasma-window-manager.c   cairo-dock-plasma-window-manager.h
		cairo-dock-plasma-virtual-desktop.c  cairo-dock-plasma-virtual-desktop.h
		cairo-dock-ext-workspaces.c          cairo-dock-ext-workspaces.h
	)

	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/wayfire-shell-unstable-v2.xml"
		BASENAME "wayfire-shell")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/plasma-window-management.xml"
		BASENAME "plasma-window-management")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/wlr-foreign-toplevel-management-unstable-v1.xml"
		BASENAME "wlr-foreign-toplevel-management")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/cosmic-toplevel-info-unstable-v1.xml"
		BASENAME "cosmic-toplevel-info")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/cosmic-toplevel-management-unstable-v1.xml"
		BASENAME "cosmic-toplevel-management")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/cosmic-overlap-notify-unstable-v1.xml"
		BASENAME "cosmic-overlap-notify")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/cosmic-workspace-unstable-v1.xml"
		BASENAME "cosmic-workspace")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/ext-workspace-v1.xml"
		BASENAME "ext-workspace")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/ext-foreign-toplevel-list-v1.xml"
		BASENAME "ext-toplevel-list")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/plasma-virtual-desktop.xml"
		BASENAME "plasma-virtual-desktop")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/wlr-layer-shell-unstable-v1.xml"
		BASENAME "layer-shell")
	ecm_add_wayland_client_protocol(
		impl_SRCS
		PROTOCOL "proto/xdg-shell.xml"
		BASENAME "xdg-shell")
endif()

add_library(implementations STATIC ${impl_SRCS})
add_definitions (-fPIC)
add_definitions (-DSHARE_DATA_DIR="${pkgdatadir}")

link_directories(
	${PACKAGE_LIBRARY_DIRS}
	${WAYLAND_LIBRARY_DIRS}
	${WAYLAND_EGL_LIBRARY_DIRS}
	${GTKLAYERSHELL_LIBRARY_DIRS}
	${EGL_LIBRARY_DIRS}
	${GTK_LIBRARY_DIRS}
	${JSON_LIBRARY_DIRS})

include_directories(
	${PACKAGE_INCLUDE_DIRS}
	${WAYLAND_INCLUDE_DIRS}
	${WAYLAND_EGL_INCLUDE_DIRS}
	${GTKLAYERSHELL_INCLUDE_DIRS}
	${EGL_INCLUDE_DIRS}
	${GTK_INCLUDE_DIRS}
	${JSON_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/src/gldit
	${CMAKE_BINARY_DIR}/src/gldit
	${CMAKE_SOURCE_DIR}/src/implementations
	${CMAKE_CURRENT_BINARY_DIR})

########### install files ###############

install (FILES
	cairo-dock-gauge.h
	cairo-dock-graph.h
	cairo-dock-progressbar.h
	cairo-dock-wayland-manager.h
	DESTINATION ${includedir}/cairo-dock/implementations)  # thoses are needed to expose the attributes of the data-renderers to the plug-ins.

=== data/desktop-manager/gnome-session-3.28/CMakeLists.txt ===
install (FILES
	cairo-dock-compiz.desktop
	cairo-dock-metacity.desktop
	DESTINATION ${datadir}/xsessions)

install (FILES
	cairo-dock-compiz.session
	cairo-dock-metacity.session
	DESTINATION ${datadir}/gnome-session/sessions)

=== data/desktop-manager/gnome-session-3.36/CMakeLists.txt ===
install (FILES
	cairo-dock-compiz.desktop
	cairo-dock-metacity.desktop
	DESTINATION ${datadir}/xsessions)

install (FILES
	cairo-dock-compiz.session
	cairo-dock-metacity.session
	DESTINATION ${datadir}/gnome-session/sessions)

install (FILES
	gnome-session-x11@cairo-dock-compiz.target
	gnome-session-x11@cairo-dock-metacity.target
	DESTINATION ${unitdir})

=== data/gauges/turbo-night-fuel/CMakeLists.txt ===

########### install files ###############

install(FILES  background.svg 	foreground.svg 	needle.svg 	theme.xml 	readme preview DESTINATION ${pkgdatadir}/gauges/Turbo-night-fuel )

=== debian/changelog ===
cairo-dock (3.6.0-0.1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 18 Oct 2025 13:25:40 -0700

cairo-dock (3.6.0-ppa1~ubuntu22.04) jammy; urgency=medium

  * New upstream release.

 -- Daniel Kondor <kondor.dani@gmail.com>  Sun, 28 Sep 2025 22:51:32 +0100

cairo-dock (3.5.99-1) jammy; urgency=medium

  * New upstream release.
  * Initial support for Wayland.
  * Add a .service file for Systemd
  * Split out session files to a separate package.
  
 -- Daniel Kondor <kondor.dani@gmail.com>  Sat, 9 Mar 2024 23:16:01 +0100

cairo-dock (3.5.0) unreleased

  * Update to 3.5.0
  * Several bug fixes since the last release.
  
 -- Daniel Kondor <kondor.dani@gmail.com>  Sat, 9 Mar 2024 23:16:00 +0100

=== debian/control ===
Source: cairo-dock
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Daniel Kondor <kondor.dani@gmail.com>
Build-Depends: cmake (>= 3.16.0),
               debhelper (>= 10),
               debhelper-compat (= 12),
               dpkg-dev (>= 1.16.1~),
               extra-cmake-modules,
               intltool,
               libcairo2-dev | libcairo-dev,
               libcurl4-gnutls-dev,
               libdbus-glib-1-dev,
               libglib2.0-dev (>= 2.40.0),
               libglu1-mesa-dev | libglu-dev,
               libglvnd-dev | libgl-dev,
               libgtk-3-dev (>= 3.22.0),
               libgtk-layer-shell-dev (>= 0.6.0),
               libjson-c-dev,
               libpango1.0-dev,
               librsvg2-dev,
               libwayland-bin,
               libxcomposite-dev,
               libxml2-dev,
               libxrandr-dev,
               libxrender-dev,
               libxtst-dev,
               pkgconf,
               quilt,
               systemd
Standards-Version: 4.5.0
Homepage: http://www.glx-dock.org/

Package: cairo-dock
Architecture: any
Depends: cairo-dock-core (= ${binary:Version}),
         cairo-dock-plug-ins (>= 3.6.0),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: cairo-dock-gnome-session
Description: Metapackage for cairo-dock
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This is metapackage that provides the components necessary for running
 Cairo-dock. This installs a cairo-dock-core application and cairo-dock-plugins
 package easily.

Package: cairo-dock-core
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libwayland-egl1, ${misc:Depends}, ${shlibs:Depends}
Breaks: cairo-dock (<= 2.1.3.5-2), cairo-dock-plug-in-data (<< 3.6.0)
Replaces: cairo-dock (<= 2.1.3.5-2)
Provides: cairo-dock
Recommends: cairo-dock-plugins (>= 3.6.0), curl
Description: Light eye-candy fully themable animated dock for Linux desktop
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This package provides Cairo-dock-core application.

Package: cairo-dock-gnome-session
Architecture: any
Depends: cairo-dock-core (>= 3.6.0),
         cairo-dock-gnome-integration-plug-in,
         cairo-dock-plug-ins (>= 3.6.0),
         compiz | metacity,
         gnome-flashback,
         gnome-session-bin,
         gnome-settings-daemon (>= 3.24),
         ${misc:Depends}
Description: An X11 desktop session for Cairo-Dock
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This package provides a desktop environment using Cairo-Dock, either the
 Compiz or Metacity window manager and GNOME components.

Package: cairo-dock-dev
Section: devel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: cairo-dock-core (= ${binary:Version}),
         libcairo2-dev | libcairo-dev,
         libcurl4-gnutls-dev,
         libdbus-glib-1-dev,
         libglib2.0-dev,
         libglu1-mesa-dev | libglu-dev,
         libglvnd-dev | libgl-dev,
         libgtk-3-dev (>= 3.22.0),
         libgtk-layer-shell-dev (>= 0.6.0),
         librsvg2-dev,
         libwayland-dev,
         libxcomposite-dev,
         libxml2-dev,
         libxrandr-dev,
         libxrender-dev,
         libxtst-dev,
         ${misc:Depends}
Description: Cairo-dock development file
 Cairo-dock has a family-likeness with OS X dock, but with more options.
 It uses cairo to render nice graphics, and Glitz to use hardware acceleration.
 It's fully configurable and can be a taskbar too.
 You can easily plug applets into it.
 .
 This package provides Cairo-dock development file.

=== debian/watch ===
version=4
opts="searchmode=plain, \
  pgpmode=none, \
  dversionmangle=auto" \
https://api.github.com/repos/Cairo-Dock/cairo-dock-core/releases \
https://api.github.com/repos/Cairo-Dock/cairo-dock-core/tarball/@ANY_VERSION@ \
debian
